using System.Drawing;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using com.airbus.pm00.model;
using System.Reflection;
using Excel;
using System.Windows.Forms;

namespace com.airbus.pm00.controller
{
    public class CtrlExcelExportFleetAC
    {
        private static CtrlExcelExportFleetAC _CtrlExcelExportFleetAC_Singleton = null;

        public CtrlExcelExportFleetAC()
        {
        }

        public static CtrlExcelExportFleetAC GetInstance()
        {
            //creer une nouvelle instance s il n'en existe pas deja une autre
            if (_CtrlExcelExportFleetAC_Singleton == null) _CtrlExcelExportFleetAC_Singleton = new CtrlExcelExportFleetAC();
            return _CtrlExcelExportFleetAC_Singleton;
        }

        //Add the hyperlinks to IP front office for fleets and msns
        public void CellExported(CellExportedEventArgs e, int currentLanguage)
        {
            string url = "";
            //Fleets
            if (e.GridRow.Band.Key == BusFleetAC.CNameFleet)
            {
                if (e.GridColumn.Header.Caption == "Fleet Name")
                {
                    url = BusParameters.GetInstance().GenerateFleetIPHyperlink(BusProject.GetInstance().GetCurrentProgramCode(), e.Value.ToString());
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula("=HYPERLINK(\"" + url + "\",\"" + e.Value.ToString() + "\")");
                    //if (currentLanguage == 2) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula("=LIEN_HYPERTEXTE(\"" + url + "\",\"" + e.Value.ToString() + "\")");
                    //else if (currentLanguage == 4) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula("=HIPERVINCULO(\"" + url + "\",\"" + e.Value.ToString() + "\")");
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.Font.UnderlineStyle = Infragistics.Documents.Excel.FontUnderlineStyle.Single;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.Font.Color = Color.Blue;
                }
            }
            //Msns
            else if (e.GridRow.Band.Key == BusFleetAC.CNameRelFleetAc)
            {
                if (e.GridColumn.Header.Caption == "MSN")
                {
                    url = BusParameters.GetInstance().GenerateMsnIPHyperlink(BusProject.GetInstance().GetCurrentProgramCode(), e.Value.ToString());
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula("=HYPERLINK(\"" + url + "\",\"" + e.Value.ToString() + "\")");
                    //if (currentLanguage == 2) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula("=LIEN_HYPERTEXTE(\"" + url + "\",\"" + e.Value.ToString() + "\")");
                    //else if (currentLanguage == 4) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula("=HIPERVINCULO(\"" + url + "\",\"" + e.Value.ToString() + "\")");
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.Font.UnderlineStyle = Infragistics.Documents.Excel.FontUnderlineStyle.Single;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.Font.Color = Color.Blue;
                }
            }       
        }
    }
}
