using System.Drawing;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using com.airbus.pm00.model;
using Infragistics.Win.UltraWinGrid;
using System.Collections;
using com.airbus.pm00.controller.util;
using System.IO;
using System.Xml;
using System.Windows.Forms;


namespace com.airbus.pm00.controller
{
	public class CtrlExcelExportOutstandingPoint
	{
		private static CtrlExcelExportOutstandingPoint _CtrlExcelExportOutstandingPoint_Singleton = null;

		public int nbColumnsOutstandingPoint = 0;
		private bool actionLineOutstandingPoint = false;
		private int nbActionsOutstandingPoint = 0;
		private int rememberCurrentRowOutstandingPoint = 0;

        private int nbColumnsLink = 0;
        private int LinkHeaderLine = 0;
        private int rememberCurrentRowLink = 0;
        private bool LinkLine = false;

		public int lastOutstandingPointColumn = 0;
		public int lastOutstandingPointRow = 0;

        public int columnToIdentifyOutPointOrLink = 60;
        public ArrayList LinksList = new ArrayList();
        public int nbColumnsAction = 0;
        public int columnSelectedIndex = 0;

		public CtrlExcelExportOutstandingPoint()
		{
		}

		public static CtrlExcelExportOutstandingPoint GetInstance()
		{
			//creer une nouvelle instance s il n'en existe pas deja une autre
			if(_CtrlExcelExportOutstandingPoint_Singleton == null) 	_CtrlExcelExportOutstandingPoint_Singleton = new CtrlExcelExportOutstandingPoint();
			return _CtrlExcelExportOutstandingPoint_Singleton;
		}

		public void BeginExport(BeginExportEventArgs e)
		{
			nbColumnsOutstandingPoint = 0;
			nbActionsOutstandingPoint = 0;
			rememberCurrentRowOutstandingPoint = 0;
			lastOutstandingPointColumn = 0;
			lastOutstandingPointRow = 0;

            nbColumnsLink = 0;
            LinkHeaderLine = 0;
            rememberCurrentRowLink = 0;
            LinkLine = false;

            LinksList.Clear();

            nbColumnsAction = 0;

            foreach (UltraGridColumn col in CtrlMain.GetInstance().UiM.UgrOutstandingPoints.DisplayLayout.Bands[BusOutstandingPoints.CNameRelOustandingActions].Columns)
            {
                if (col.IsVisibleInLayout) nbColumnsAction++;
            }
		}

        public void HeaderRowExporting(HeaderRowExportingEventArgs e, int rowOffset, int columnOffset)
		{
			if (e.Band.Columns.Exists("C_ACTION_ID"))
			{
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusOutstandingPoints.CNameOutstandingPoint)
                {
				    rememberCurrentRowOutstandingPoint = e.CurrentRowIndex-2;
				    e.CurrentColumnIndex = nbColumnsOutstandingPoint+1;
				    e.CurrentRowIndex = rowOffset;
                }
                else if (parentBand.Key == BusOutstandingPoints.CNameRelOustandingLinks)
                {
                    rememberCurrentRowLink = e.CurrentRowIndex-2;
                    e.CurrentColumnIndex = nbColumnsLink+1;
                    e.CurrentRowIndex = LinkHeaderLine;
                }
			}
            else if (e.Band.Key == BusOutstandingPoints.CNameRelOustandingLinks)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                if (actionLineOutstandingPoint)
                {
                    //if (nbActionsRfc > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                    MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsOutstandingPoint, nbColumnsOutstandingPoint);
                    nbActionsOutstandingPoint = 0;
                    actionLineOutstandingPoint = false;
                }
                LinkHeaderLine = e.CurrentRowIndex;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
            }
		}

		public void HeaderRowExported(HeaderRowExportedEventArgs e)
		{
			if (e.Band.Columns.Exists("C_ACTION_ID"))
			{
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusOutstandingPoints.CNameOutstandingPoint)
                {
				    e.CurrentRowIndex = rememberCurrentRowOutstandingPoint;
                }
                else if (parentBand.Key == BusOutstandingPoints.CNameRelOustandingLinks)
                {
                    e.CurrentRowIndex = rememberCurrentRowLink;
                }
			}
		}

		public void RowExporting(RowExportingEventArgs e, int columnOffset)
		{          
			if (e.GridRow.Band.Columns.Exists("C_ACTION_ID"))
			{
                UltraGridBand parentBand = e.GridRow.Band.ParentBand;
                if (parentBand.Key == BusOutstandingPoints.CNameOutstandingPoint)
                {
				    e.CurrentColumnIndex = nbColumnsOutstandingPoint+1;
				    nbActionsOutstandingPoint = nbActionsOutstandingPoint+1;
				    actionLineOutstandingPoint = true;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "O";
                }
                else if (parentBand.Key == BusOutstandingPoints.CNameRelOustandingLinks)
                {
                    //band rfc action
                    e.CurrentColumnIndex = nbColumnsLink+1;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
                }
			}
			else if (actionLineOutstandingPoint)
			{
				e.CurrentRowIndex = e.CurrentRowIndex-1;
				//if (nbActionsMscn > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsMscn, nbColumnsMscn);
				MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsOutstandingPoint, nbColumnsOutstandingPoint);
				nbActionsOutstandingPoint = 0;
				actionLineOutstandingPoint = false;
			}
            if (e.GridRow.Band.Key == BusOutstandingPoints.CNameOutstandingPoint && LinkLine)
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
            if (e.GridRow.Band.Key == BusOutstandingPoints.CNameRelOustandingLinks)
                LinkLine = true;
            else LinkLine = false;

            if (e.GridRow.Band.Key == BusOutstandingPoints.CNameRelOustandingLinks)
            {
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
            }
            else if (e.GridRow.Band.Key == BusOutstandingPoints.CNameOutstandingPoint)
            {
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "O";
            }
		}

		public void HeaderCellExported(HeaderCellExportedEventArgs e)
		{
			if (e.CurrentColumnIndex > lastOutstandingPointColumn) lastOutstandingPointColumn = e.CurrentColumnIndex;
            if (e.GridRow.Band.Key == BusOutstandingPoints.CNameOutstandingPoint)
            {
                //if (!e.GridRow.Band.Columns.Exists("C_ACTION_ID")) 
                nbColumnsOutstandingPoint = e.CurrentColumnIndex;
            }
            else if (e.GridRow.Band.Key == BusOutstandingPoints.CNameRelOustandingLinks)
            {
                nbColumnsLink = e.CurrentColumnIndex;
            }
		}

		public void CellExported(CellExportedEventArgs e)
        {
            //ArrayList _ListLinks = new ArrayList();
          
			if (e.GridColumn.Key == "C_OUTSTANDING_SELECTED")
			{
				if (int.Parse(e.Value.ToString()) == 1) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "*";
				else e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "";
			}
			if (e.GridRow.Band.Key == BusOutstandingPoints.CNameOutstandingPoint)
			{
                //Rajouter des bordures noires  chaque MSCN en Haut, en Bas et  Droite
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsOutstandingPoint)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsOutstandingPoint].CellFormat.RightBorderColor = Color.Black;
                if (e.CurrentWorksheet.Rows[0].Cells[e.CurrentColumnIndex].Value.ToString() == "Rank") //"Title"  //Correction point 214 (08/11/2010)
                {
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.LeftBorderColor = Color.Black;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.RightBorderColor = Color.Gray;
                }
            }
            else if (e.GridRow.Band.Key == BusOutstandingPoints.CNameRelOustandingLinks)
            {
                //Rajouter des bordures noires  chaque Rfc Global en Haut, en Bas,  Droite et  Gauche
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsLink)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsLink].CellFormat.RightBorderColor = Color.Black;
                if (e.CurrentColumnIndex == 1)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[1].CellFormat.LeftBorderColor = Color.Black;

                //Save the Links excel cells adresses 
                if (e.GridColumn.Header.Caption == "Link")
                {
                    if ((e.Value!=null) && (e.Value.ToString()!=""))
                        LinksList.Add(new Link(e.CurrentRowIndex + 1, e.CurrentColumnIndex + 1, e.Value.ToString()));
                }
            }

            if (e.GridColumn.Editor.ToString() == "Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor")
            {
                //CellValue is the text with balises
                string CellValue = e.GridRow.Cells[e.GridColumn.Index].Value.ToString();
                //Replace "&edsp;" by "&#32;" in order to be recognized by xml document
                CellValue = CellValue.Replace("&edsp;", "&#32;");

                //Cell text is the text without balises
                string CellText = e.GridRow.Cells[e.GridColumn.Index].Text;
                //Delete \r . Only \n is needed for line return
                CellText = CellText.Replace("\r", "");

                if (CellValue.Contains("<span") && CellValue.Contains("</span>"))
                {
                    FormattedString StringValue = new FormattedString(CellText);
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = StringValue;
                    MemoryStream ms = new MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes("<span>" + CellValue + "</span>"));
                    XmlDocument xmlDoc = new XmlDocument();
                    xmlDoc.Load(ms);
                    XmlNode Node = xmlDoc.SelectSingleNode("span");
                    CtrlUtils.AddSpanPositions(Node, 0);
                    CtrlUtils.FormatInfragisticsExcelString(StringValue, Node);
                }
            }
		}

        public void EndExport(EndExportEventArgs e, int rowOffset, int columnOffset) //, bool isFiltered)
		{
			lastOutstandingPointRow = e.CurrentRowIndex;
            //if (isFiltered) lastOutstandingPointRow -= 1;
            if (actionLineOutstandingPoint)
			{
                MergeActions(e.CurrentWorksheet, lastOutstandingPointRow, columnOffset, nbActionsOutstandingPoint, nbColumnsOutstandingPoint);
				nbActionsOutstandingPoint = 0;
				actionLineOutstandingPoint = false;
			}
            for (int iRow = rowOffset; iRow <= lastOutstandingPointRow; iRow++)
			{
                //e.CurrentWorksheet.Rows[iRow].Expanded = true; //Deprecated
                e.CurrentWorksheet.Rows[iRow].Hidden = false;
                e.CurrentWorksheet.Rows[iRow].OutlineLevel = 0;
                if (e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyOutPointOrLink].Value != null)
                {
                    if (e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyOutPointOrLink].Value.ToString() == "L")
                        e.CurrentWorksheet.Rows[iRow].OutlineLevel = 1;
                    else
                    {
                        if (BusOutstandingPoints.GetInstance().Tables[BusOutstandingPoints.CNameAction].Rows.Count != 0)
                        {
                            //Set rfc actions lines borders                           
                              //Change mde by Nitin.b 
                            //Change for error overflow
                            //for (int iColumn = 1; iColumn <= nbColumnsAction; iColumn++)
                            for (int iColumn = 0; iColumn < nbColumnsAction; iColumn++)
                            //End by Nitin for overflow error
                            {
                                //Set top border and bottom border only when actions are not merged
                                if (!e.CurrentWorksheet.MergedCellsRegions.IsOverlappingWithMergedRegion(iRow, nbColumnsOutstandingPoint / 2, iRow, nbColumnsOutstandingPoint / 2))
                                {
                                    //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsOutstandingPoint + iColumn].CellFormat.TopBorderColor = Color.Black;
                                    //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsOutstandingPoint + iColumn].CellFormat.BottomBorderColor = Color.Black;
                                    //Change made by Nitin.b
                                    //For error -Overflow
                                   // e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.TopBorderColor = Color.Black;
                                    // e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.BottomBorderColor = Color.Black;

                                    //End by Nitin.b                         

                                    //code chhanged for evo12 by Koshlendra Pratap Singh on 23/05/2013 start
                                    if (iColumn == nbColumnsAction)
                                        e.CurrentWorksheet.Rows[iRow].Cells[iColumn + 1].CellFormat.RightBorderColor = Color.Black;
                                    //code chhanged for evo12 by Koshlendra Pratap Singh on 23/05/2013 End
                                }
                            }
                        }
                    }
                    e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyOutPointOrLink].Value = "";
                }
			}
		}

		private void MergeActions(Worksheet worksheet, int rowIndex, int columnOffset, int nbActions, int nbColumns)
		{
			//Merge Columns
			int firstRowToMerge = rowIndex-nbActions;
			int lastRowToMerge = rowIndex-1;
			//Do not merge * cells
            int firstColumnToMerge = columnOffset + 1; //By default, we consider that the * column is exported
            if (worksheet.Rows[0].Cells[0].Value.ToString() != "") firstColumnToMerge = columnOffset; //Correction point 214 (08/11/2010)
                
            if (firstRowToMerge < lastRowToMerge)
            {
                for (int iColumn = firstColumnToMerge; iColumn <= nbColumns; iColumn++)
                {
                  //  worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                    //Code updated by Koshlendra on 28/05/2013 start
                    try
                    {
                        worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                    }
                    catch (System.Exception  e)
                    {
                        MessageBox.Show(e.Message);
                    }
                    //Code updated by Koshlendra on 28/05/2013 End
                }
            }
            //Rajouter des bordures noires  la bordure du bas de la dernire ou unique action de l'ensemble d'actions appartenant  un outstanding point
            if (nbActions > 1)
            {
                for (int iColumn = 1; iColumn <= nbColumnsAction; iColumn++)
                {
                    worksheet.Rows[firstRowToMerge].Cells[nbColumns + iColumn].CellFormat.TopBorderColor = Color.Black;
                    worksheet.Rows[lastRowToMerge].Cells[nbColumns + iColumn].CellFormat.BottomBorderColor = Color.Black;
                }
            }
            //Rajouter des bordures  gauche et  droite de chaque ligne d'action
            for (int iRow = firstRowToMerge; iRow <= lastRowToMerge; iRow++)
            {
                //worksheet.Rows[iRow].Cells[nbColumns + 1].CellFormat.LeftBorderColor = Color.Black;
                worksheet.Rows[iRow].Cells[nbColumns + nbColumnsAction].CellFormat.RightBorderColor = Color.Black;
            }
			
            //recopier la valeur de l'* sur toutes les lignes
			int starColumn = columnOffset;
			for (int iRow = firstRowToMerge+1; iRow<=lastRowToMerge; iRow++)
			{
                //worksheet.Rows[iRow].Cells[starColumn].
				worksheet.Rows[iRow].Cells[starColumn].Value = worksheet.Rows[firstRowToMerge].Cells[starColumn].Value;
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.SetFormatting(worksheet.Rows[firstRowToMerge].Cells[starColumn].CellFormat);
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderStyle = CellBorderLineStyle.Thin;
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderColor = Color.LightGray;
			}
        }
	}
}
